﻿#include <iostream>
#include "BST.h"
using namespace std;

BST::BST():root(NULL) {}

BST::BST(int tab[], int size) {
	root = NULL; // 5 linijka nie chce sie u mnie wykonac z jakiegos powodu, dlatego dorzucam to
	for (int i = 0; i < size; i++)
		insert(root, tab[i]);
}

bool BST::insert(BSTNode*& node, int wartosc) {
	if (node == NULL) { // tworzymy i dołączamy węzeł          
		node = new BSTNode;
		node->data = wartosc;
		node->left = NULL;
		node->right = NULL;
		return true;
	}
	else
		if (wartosc < node->data) return insert(node->left, wartosc);    // rekurencyjne wywolanie              
		else
			if (wartosc > node->data) return insert(node->right, wartosc); // rekurencyjne wywolanie            
		  // uwaga: liczby powtarzające się nie są dodawane do drzewa 
	
	return false;
}

BSTNode* BST::search(int key) {
	return search(root, key);
}

BSTNode* BST::search(BSTNode* node, int key) {
	BSTNode* p = NULL;

	BSTNode* tmp = node;
	while(tmp != NULL) {
		if(tmp->data == key) {
			p = tmp;
			break;
		} else {
			if(tmp->data > key) tmp = tmp->left;
			else tmp = tmp->right;
		}
	}

	return p;
}

int BST::minKey() {
	return minKey(root);
}

int BST::minKey(BSTNode* node) {
	BSTNode* tmp = node;

	int minn = tmp->data;

	while(tmp != NULL) {
		if(tmp->left != NULL) {
			tmp = tmp->left;
			minn = tmp->data;
		} else {
			break;
		}
	}

	return minn;
}

int BST::maxKey() {
	int maxx = BST::root->data;

	BSTNode* tmp = BST::root;
	while(tmp != NULL) {
		if(tmp->right != NULL) {
			tmp = tmp->right;
			maxx = tmp->data;
		} else {
			break;
		}
	}

	return maxx;
}

void BST::inorder(BSTNode* x) {
	if(x->left != NULL) inorder(x->left);
	cout << x->data << " ";
	if(x->right != NULL) inorder(x->right);
}

void BST::preorder(BSTNode* x) {
	cout << x->data << " ";
	if(x->left != NULL) preorder(x->left);
	if(x->right != NULL) preorder(x->right);
}

void BST::postorder(BSTNode* x) {
	if(x->left != NULL) postorder(x->left);
	if(x->right != NULL) postorder(x->right);
	cout << x->data << " ";
}

void BST::print(BSTNode* x){
	if (!x->left && !x->right) return;

	cout << x->data << " : lewy-> ";
	if (x->left) cout << x->left->data;
	else        cout << "NULL";
	
	cout << ", prawy-> ";
	if (x->right) cout << x->right->data;
	else         cout << "NULL";
	cout << endl;
	
	if (x->left)  print(x->left);
	if (x->right) print(x->right);
}

void BST::remove(BSTNode* x) {
	if (!x) return;
	remove(x->left);
	remove(x->right);
	cout << "usuwam " << x->data << endl;
	delete x;
}